//: C06:Comparison.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// STL algoritmy pro porovnávání rozsahů.
#include <algorithm>
#include <functional>
#include <string>
#include <vector>
#include "PrintSequence.h"
using namespace std;

int main() {
	// Řetězce poskytují pohodlný způsob jak vytvářet 
	// rozsahy znaků, ale normálně byste je měli 
	// porozhlédnout po nativních řetězcových operacích:
  string s1("Toto je test");
  string s2("Toto je Test");
  cout << "s1: " << s1 << endl << "s2: " << s2 << endl;
  cout << "porovnání s1 & s1: "
       << equal(s1.begin(), s1.end(), s1.begin()) << endl;
  cout << "porovnání s1 & s2: "
       << equal(s1.begin(), s1.end(), s2.begin()) << endl;
  cout << "lexicographical_compare s1 & s1: "
       << lexicographical_compare(s1.begin(), s1.end(),
          s1.begin(), s1.end()) <<  endl;
  cout << "lexicographical_compare s1 & s2: "
       << lexicographical_compare(s1.begin(), s1.end(),
          s2.begin(), s2.end()) << endl;
  cout << "lexicographical_compare s2 & s1: "
       << lexicographical_compare(s2.begin(), s2.end(),
          s1.begin(), s1.end()) << endl;
  cout << "lexicographical_compare zkrácený "
          "s1 & s2 s plnou délkou: " << endl;
  string s3(s1);
  while(s3.length() != 0) {
    bool result = lexicographical_compare(
      s3.begin(), s3.end(), s2.begin(),s2.end());
    cout << s3 << endl << s2 << ", výsledek = "
         << result << endl;
    if(result == true) break;
    s3 = s3.substr(0, s3.length() - 1);
  }
  pair<string::iterator, string::iterator> p =
    mismatch(s1.begin(), s1.end(), s2.begin());
  print(p.first, s1.end(), "p.first", "");
  print(p.second, s2.end(), "p.second","");
} ///:~
